%define anolis_release 1
%global gitcommit 560379ee67db48382ccc3ab3de866e239fd74ca8
%global gitshortcommit %(c=%{gitcommit}; echo ${c:0:7})

Name:           memstrack
Version:        0.2.5
Release:        %{anolis_release}%{?dist}
Summary:        A memory allocation tracer, like a hot spot analyzer for memory allocation
License:        GPLv3
URL:            https://github.com/ryncsn/memstrack
Source:         %{url}/archive/%{gitcommit}/memstrack-%{gitshortcommit}.tar.gz
BuildRequires:  make, gcc > 12.0, ncurses-devel

%description
A runtime memory allocation tracer, like a hot spot analyzer for memory
allocation, can help analyze overall memory usage, peak memory usage,
kernel module memory usage, all combined with stacktrace. Userspace
memory trace is planned and not yet implemented.

This tool works by tracing all page-level memory allocation events in
kernel (currently supports using perf or ftrace), and actively integrate
the events into a stack trace tree. It can also work with kernel's page
owner log file and use as a memory usage viewer.

To analyze the memory usage of a certain program/module/code, you have
to start memstrack before start/load the program, since memstrack can
only track the allocation events at runtime.

%package doc
Summary: Documentation files for %{name}
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
The %{name}-doc package contains documentation files for %{name}

%prep
%autosetup -n memstrack-%{gitcommit}

%build
%{set_build_flags}
%{make_build}

%install
mkdir -p %{buildroot}/%{_bindir}
install -p -m 0755 memstrack %{buildroot}/%{_bindir}

%files
%license LICENSE
%{_bindir}/memstrack

%files doc
%doc README.md

%changelog
* Tue Mar 18 2025 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.2.5-1
- Update to 0.2.5 from 0.2.2

* Wed Dec 27 2023 Chang Gao <gc-taifu@linux.alibaba.com> - 0.2.2-4
- Correct the source url

* Tue Apr 11 2023 Ziyang Zhang <ZiyangZhang@linux.alibaba.com> - 0.2.2-3
- Optimize spec file

* Mon Mar 20 2023 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.2.2-2
- Add doc pkg

* Thu Mar 10 2022 <liwei.glw@linux.alibaba.com> - 0.2.2-1
- Init version from upstream v0.2.2
